=== src/backends/interfaces/audio/CMakeLists.txt ===
--- 
+++ 
@@ -31,9 +31,9 @@
 IF(${AUDIO_BACKEND} MATCHES "pulse")
     add_subdirectory(pulse)
 ENDIF(${AUDIO_BACKEND} MATCHES "pulse")
-IF(${AUDIO_BACKEND} MATCHES "openal")
-    add_subdirectory(openal)
-ENDIF(${AUDIO_BACKEND} MATCHES "openal")
+IF(${AUDIO_BACKEND} MATCHES "winmm")
+    add_subdirectory(winmm)
+ENDIF()
 IF(${AUDIO_BACKEND} MATCHES "sdl")
     add_subdirectory(sdl)
 ENDIF(${AUDIO_BACKEND} MATCHES "sdl")
