=== debian/changelog ===
lightspark (0.5.4-0ubuntu1) precise; urgency=low

  * New upstream release
  * debian/docs: Remove TODO
  * debian/patches/glibmm_recmutex_hang.patch: Workaround for a hang
    at program exit.

 -- Jani Monoses <jani@ubuntu.com>  Tue, 24 Jan 2012 23:49:30 +0200

lightspark (0.5.2.1-0ubuntu1) precise; urgency=low

  * New upstream patch release.

 -- Jani Monoses <jani@ubuntu.com>  Fri, 28 Oct 2011 23:20:34 +0300

lightspark (0.5.2-0ubuntu1) precise; urgency=low

  * New upstream release
  * debian/control: depend on llvm-2.8 instead of llvm-2.7

 -- Jani Monoses <jani@ubuntu.com>  Fri, 28 Oct 2011 16:18:07 +0300
