=== debian/control ===
--- 
+++ 
@@ -3,7 +3,7 @@
 Priority: optional
 Maintainer: Debian Flash Maintainers <pkg-flash-devel@lists.alioth.debian.org>
 Uploaders: Didier Raboud <odyx@debian.org>
-Build-Depends: debhelper (>= 8.9.0~),
+Build-Depends: debhelper (>= 7.0.50),
   cmake,
   nasm,
   llvm-2.8-dev (>= 2.8) | llvm-dev (>= 2.8),
@@ -14,6 +14,8 @@
   libavutil-dev,
   libx11-dev,
   libglu1-mesa-dev,
+  libgl1-mesa-dev [!armel],
+  libgles2-mesa-dev [armel] | libgles2-dev [armel],
   libglew-dev,
   libboost-filesystem-dev,
   libboost-system-dev,
@@ -24,6 +26,7 @@
   libgtk2.0-dev,
   libjpeg-dev,
   libxml++2.6-dev (>= 2.33.1),
+  gnash-common
 Standards-Version: 3.9.2
 Homepage: http://lightspark.sf.net
 Vcs-Git: git://git.debian.org/pkg-flash/lightspark.git
