=== debian/rules ===
--- 
+++ 
@@ -1,7 +1,21 @@
 #!/usr/bin/make -f
 
 %:
-	dh $@ --parallel
+	dh --parallel $@
+
+DEB_HOST_ARCH   := $(shell dpkg-architecture -qDEB_HOST_ARCH)
+
+ifeq ($(DEB_HOST_ARCH),armel)
+	GLES2=1
+else
+	GLES2=0
+endif
+
+override_dh_auto_configure:
+	dh_auto_configure -- \
+	    -DCOMPILE_PLUGIN=1 \
+	    -DCMAKE_BUILD_TYPE=Debian \
+		-DENABLE_GLES2=$(GLES2)
 
 override_dh_strip:
 	dh_strip --dbg-package=lightspark-dbg
@@ -14,7 +28,7 @@
 	    dh_shlibdeps -Llightspark-common \
 	    -pbrowser-plugin-lightspark -plightspark \
 	    -- -Ldebian/common.shlibs
-	
+
 	dh_shlibdeps --remaining-packages
 
 override_dh_makeshlibs:
