## lightspark 0.5.4.1

=== CMakeLists.txt ===
--- 
+++ 
@@ -26,7 +26,7 @@
 SET(MAJOR_VERSION "0")
 SET(MINOR_VERSION "5")
 SET(PATCH_VERSION "4")
-SET(SUBPATCH_VERSION "0")
+SET(SUBPATCH_VERSION "1")
 
 IF(EXISTS "${CMAKE_SOURCE_DIR}/.git/")
 	SET(GIT_VERSION "-git")
