=== debian/changelog ===
lightspark (0.5.4.1-1) unstable; urgency=low

  * New 0.5.4.1 upstream release
    - Support also targets without 8 bit per pixel depth
      (Closes: #647257, LP: #910837)
  * Build against LLVM-3.0.

 -- Didier Raboud <odyx@debian.org>  Thu, 02 Feb 2012 10:25:56 +0100

lightspark (0.5.4-1) unstable; urgency=low

  * New 0.5.4 upstream release
    - ENABLE_RTMP=1 by default (#647149 fixed upstream)

 -- Didier Raboud <odyx@debian.org>  Tue, 31 Jan 2012 13:54:07 +0100

lightspark (0.5.3-2) unstable; urgency=low

  [ Kai Wasserbäch ]
  * Also build the sdl audio backend. (Closes: #643839)
    - Build-Depends: Add libsdl1.2-dev.

  [ Didier Raboud ]
  * Enable RTMP support. (Closes: #647149)

 -- Didier Raboud <odyx@debian.org>  Mon, 02 Jan 2012 17:52:26 +0100
